/* 
 *  loadform.c - Parse html form with includes.
 *
 *  Copyright (c) 1998  Maxim Chirkov <mc@skyway.ru>  
 */

#include	"getstatd.h"

#define TMP_BUFF_SIZE 4096	

mime_types http_answer[] = {"",
			    "text/html",
			    "text/plain",
			    "image/gif",
			    "image/jpeg",
			    "text/html"};

form_item includes[] = {{"@WHO@",inc_who},
			{"@LINE@",inc_line},
			{"@LAST@",inc_last},
			{"@USERS@",inc_users},
			{"@PLUGINHEADER1@",inc_pluginheader1},
			{"@PLUGIN1@",inc_plugin1},
			{"@PLUGINHEADER2@",inc_pluginheader2},
			{"@PLUGIN2@",inc_plugin2},
			{"@PLUGINHEADER3@",inc_pluginheader3},
			{"@PLUGIN3@",inc_plugin3},
			{"@PLUGINHEADER4@",inc_pluginheader4},
			{"@PLUGIN4@",inc_plugin4},
			{"@STATUSER@",inc_statususer},
			{"@FROMDATE@",inc_fromdate},
			{"@S_LONGDATE@",inc_s_longdate},
			{"@TODATA@",inc_todate},
			{"@E_LONGDATE@",inc_e_longdate},
			{"@STATISTIC@",inc_statistic},
			{"@SUMHOUR@",inc_sumhour},
			{"@SUMMIN@",inc_summin},
			{"@VERSION@",inc_version},
			{"@REFRESH@",inc_refresh},
			{"@SUMPRICE@",inc_tp_sumprice},
			{"@REAL_SUMPRICE@",inc_tp_real_sumprice},
			{"@S_MONTH@",inc_s_month},
			{"@S_DAY@",inc_s_day},
			{"@S_HOUR@",inc_s_hour},
			{"@S_YEAR@",inc_s_year},
			{"@E_MONTH@",inc_e_month},
			{"@E_DAY@",inc_e_day},
			{"@E_HOUR@",inc_e_hour},
			{"@E_YEAR@",inc_e_year},
			{0,0}};

form_sub_item sub_includes[] = {{"@SUM_SUB_HOUR_",inc_tp_sumhour},
			{"@SUM_SUB_MIN_",inc_tp_summin},
			{"@RSUM_SUB_HOUR_",inc_tp_rsumhour},
			{"@RSUM_SUB_MIN_",inc_tp_rsummin},
			{"@PRICE_",inc_tp_price},
			{0,0}};

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
int perform_includes(int socket, char * buff ){
	int I, J, Flag = 0, ExitFlag = 0;
	char	* tmp_buff  = (char *) my_malloc(TMP_BUFF_SIZE+1);
	char	* old_buff;
	char 	* opp_end;
	int	str_size;

    strncpy(tmp_buff, buff, TMP_BUFF_SIZE);
    tmp_buff[TMP_BUFF_SIZE] = '\0';
    old_buff = tmp_buff;
    J = 0;
    do {
        for (;( tmp_buff[J] != '\0') && ( tmp_buff[J] != '@'); J++){;}

	if ( tmp_buff[J] != '\0'){

    	    for ( I = 0; includes[I].name != 0; I++){

		    str_size = strlen(includes[I].name);
		    if (strncasecmp(includes[I].name, tmp_buff+J, str_size) == 0){
			tmp_buff[J] = '\0';
		        writeline(socket,tmp_buff);    	    	        
			(includes[I].parser)();
			
			tmp_buff += str_size + J;
			J = 0;
			Flag++;
			break;
		    }
    	    }

    	    for ( I = 0; sub_includes[I].name != 0; I++){
		    
		    str_size = strlen(sub_includes[I].name);
		    if (strncasecmp(sub_includes[I].name,tmp_buff+J, str_size ) == 0){

                        opp_end = strchr(tmp_buff+str_size+J,'@');
			if (opp_end != NULL ){
			    opp_end[0] = '\0';
			    tmp_buff[J] = '\0';
		    	    writeline(socket,tmp_buff);
			       
			    (sub_includes[I].parser)(tmp_buff+J+str_size);
			
			    tmp_buff = opp_end + 1;
			    J = 0;
			} else {
			    log_info("Unbalanced include.");
			}
			Flag++;
			break;
		    }
    	    }
	    J++; 
	} else {
	    ExitFlag = 1;
	}
    } while (ExitFlag == 0);

    if (Flag) {
        writeline(socket,tmp_buff);    	    	        
	my_free (old_buff);
	return 0;
    } else {
        my_free (old_buff);
	return 1;
    }
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

void get_file (int socket, char * path_name, int mime_flag){
       char	* str_buff  = (char *) my_malloc(TMP_BUFF_SIZE+1);
       FILE * index_file;

  if ((index_file = fopen(path_name,"r")) == NULL) {
	log_error("can't open reguested html form.\n");
  }
  snprintf(str_buff, TMP_BUFF_SIZE,"HTTP/1.0 200 OK\nServer: getstatd/%s\nContent-type: %s\n\n" ,GETSTATD_VER, http_answer[mime_flag]);
  writeline(socket, str_buff);

  while ( fgets( str_buff, TMP_BUFF_SIZE, index_file) != NULL ){

      if (mime_flag == MIME_PHTML){
          if ( perform_includes(socket, str_buff ) != 0) {
              writeline(socket, str_buff);	  
          }
      } else {
          writeline(socket, str_buff);	  
      }
  }
  fclose(index_file);    
  my_free(str_buff);
}
